From 343511d91eac3e85f57803fca821632858bb9ba9 Mon Sep 17 00:00:00 2001
From: Nicolas Bertolo <nicolasbertolo@gmail.com>
Date: Sun, 7 Jun 2020 14:40:14 -0300
Subject: [PATCH] Don't crash when a lambda has been already loaded.

* src/pdumper.c (dump_do_dump_relocation): Skip lambdas that have been
loaded already.
---
 src/pdumper.c | 4 ++++
 1 file changed, 4 insertions(+)

diff --git a/src/pdumper.c b/src/pdumper.c
index 92ac96a8faa..594b60b143b 100644
--- a/src/pdumper.c
+++ b/src/pdumper.c
@@ -5365,6 +5365,10 @@ dump_do_dump_relocation (const uintptr_t dump_base,
 	    XSETSUBR (tem, subr);
 	    Lisp_Object *fixup =
 	      &(comp_u->data_imp_relocs[XFIXNUM (lambda_data_idx)]);
+            bool lambda_already_loaded = SUBRP (*fixup)
+              && XSUBR (*fixup)->function.a0 == func;
+            if (lambda_already_loaded)
+              return;
 	    eassert (EQ (*fixup, Qlambda_fixup));
 	    *fixup = tem;
 	    Fputhash (tem, Qnil, comp_u->lambda_gc_guard);
-- 
2.25.1.windows.1

